<?php

namespace Drupal\visualn_libraries_override\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Class OverridesSettingsForm.
 */
class OverridesSettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'visualn_libraries_override.settings',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'visualn_libraries_override_settings_form';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('visualn_libraries_override.settings');
    $form['overrides_list'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Overrides list'),
      '#description' => $this->t('List of base:override libraries pairs, for example: <em>first_module/library:second_module/another_library</em>'),
      '#default_value' => $config->get('overrides_list'),
    ];
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  // @todo: validate configuration form

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);

    $this->config('visualn_libraries_override.settings')
      ->set('overrides_list', $form_state->getValue('overrides_list'))
      ->save();

    // clear libraries cache only
    \Drupal::service('library.discovery.collector')->clear();
  }

}
